package ru.amse.pomelov.starbugs.client.gui.frames;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.DefaultBoundedRangeModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.border.EmptyBorder;

public class UserWaiting extends JFrame {
	private static final long serialVersionUID = 1L;

	private class PlayersNumber extends DefaultBoundedRangeModel {
		private static final long serialVersionUID = 1L;

		@Override
		public int getMinimum() {
			return 0;
		}

		@Override
		public int getMaximum() {
			return UserWaiting.this.maxP;
		}

		@Override
		public int getValue() {
			return UserWaiting.this.current;
		}
	
		
	}
	

	private int maxP;
	private int current = 0;
	private final PlayersNumber playersNumber = new PlayersNumber();
	private final JLabel num = new JLabel();
	
	private JPanel createTextPanel() {
		JPanel result = new JPanel(new GridLayout(1, 2, 5, 5));
		result.add(new JLabel("Players: ", JLabel.RIGHT));
		num.setText("" + current + " / " + maxP);
		result.add(num);
		result.setBorder(new EmptyBorder(5, 5, 5, 5));
		return result;
	}
	
	private JPanel createProgressPanel() {
		JPanel result = new JPanel();
		result.add(new JProgressBar(playersNumber));
		result.setBorder(new EmptyBorder(5, 5, 5, 5));
		return result;
	}
	
	public void playerJoined() {
		current++;
		num.setText("" + current + " / " + maxP);
		this.repaint();
	}
	
	public UserWaiting(int max, int cur) {
		super("Waiting for players...");
		maxP = max;
		current = cur;
		setSize(250, 100);
		setResizable(false);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setVisible(true);
		setLocation(640, 480);
		setLayout(new BorderLayout());
		add(createTextPanel(), BorderLayout.NORTH);
		add(createProgressPanel(), BorderLayout.SOUTH);
		this.repaint();
	}
	

}
