package ru.amse.pomelov.starbugs.client.gui.tools;

import java.awt.Graphics;

import ru.amse.pomelov.starbugs.config.UnitAttributes;
import ru.amse.pomelov.starbugs.turns.AbstractTurn;
import ru.amse.pomelov.starbugs.turns.BuildTurn;
import ru.amse.pomelov.starbugs.units.Edifices;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public class BuildTool extends AbstractTool {

	private final Edifices myEdificeType;

	public BuildTool(Edifices edificeType) {
		myEdificeType = edificeType;
	}
	
	public AbstractTurn generateTurn(FieldPosition object, FieldPosition subject) {
		return new BuildTurn(object, subject, myEdificeType);
	}

	public boolean needsObject() {
		return true;
	}
	
	@Override
	public void drawToolTip(Graphics g, int x, int y, int cellSize, int width, int height) {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (myEdificeType.getMask()[j][i]) {
					super.drawToolTip(g, x+i, y+j, cellSize, width, height);
				}
			}
		}
	}

	public int timeNeeded() {
		return UnitAttributes.BUILDING_START_COST;
	}
	
}
