package ru.amse.pomelov.starbugs.config;

import java.util.EnumSet;
import java.util.HashSet;
import java.util.Set;

import ru.amse.pomelov.starbugs.units.AbstractUnitTypes;
import ru.amse.pomelov.starbugs.units.Buildings;

public class UnitAttributes {
	public static final int BLOCK_COST = 2;
	public static final int BLOCK_ATTACK_RADIUS = 1;
	public static final int BLOCK_ATTACK_COST = 2;
	public static final EnumSet<AbstractUnitTypes> BLOCK_ATTACK_TYPE
			= EnumSet.of(AbstractUnitTypes.HUMAN, AbstractUnitTypes.MACHINE);

	//Human
	public static final int WORKER_COST = 2;
	public static final int WORKER_ATTACK_RADIUS = 0;
	public static final int WORKER_ATTACK_COST = 0;
	public static final EnumSet<AbstractUnitTypes> WORKER_ATTACK_TYPE
			= EnumSet.noneOf(AbstractUnitTypes.class);

	public static final int SOLDIER_COST = 2;
	public static final int SOLDIER_ATTACK_RADIUS = 1;
	public static final int SOLDIER_ATTACK_COST = 2;
	public static final EnumSet<AbstractUnitTypes> SOLDIER_ATTACK_TYPE 
			= EnumSet.of(AbstractUnitTypes.HUMAN, AbstractUnitTypes.MACHINE);
	
	public static final int ARCHER_COST = 4;
	public static final int ARCHER_ATTACK_RADIUS = 1 | 2;
	public static final int ARCHER_ATTACK_COST = 1;
	public static final EnumSet<AbstractUnitTypes> ARCHER_ATTACK_TYPE
			= EnumSet.of(AbstractUnitTypes.HUMAN);

	public static final int RUNNER_COST = 1;
	public static final int RUNNER_ATTACK_RADIUS = 0;
	public static final int RUNNER_ATTACK_COST = 0;
	public static final EnumSet<AbstractUnitTypes> RUNNER_ATTACK_TYPE
		= EnumSet.noneOf(AbstractUnitTypes.class);
	
	//Machine
	public static final int BALLISTA_COST = 6;
	public static final int BALLISTA_ATTACK_RADIUS = 1 | 2 | 4;
	public static final int BALLISTA_ATTACK_COST = 2;
	public static final EnumSet<AbstractUnitTypes> BALLISTA_ATTACK_TYPE
		= EnumSet.of(AbstractUnitTypes.HUMAN, AbstractUnitTypes.MACHINE);
	

	public static final int CATAPULT_COST = 8;
	public static final int CATAPULT_ATTACK_RADIUS = 2 | 4;
	public static final int CATAPULT_ATTACK_COST = 3;
	public static final EnumSet<AbstractUnitTypes> CATAPULT_ATTACK_TYPE
		= EnumSet.of(AbstractUnitTypes.HUMAN, AbstractUnitTypes.MACHINE, AbstractUnitTypes.BUILDING);

	public static final int TANK_COST = 10;
	public static final int TANK_ATTACK_RADIUS = 1 | 2 | 4;
	public static final int TANK_ATTACK_COST = 4;
	public static final EnumSet<AbstractUnitTypes> TANK_ATTACK_TYPE
		= EnumSet.of(AbstractUnitTypes.HUMAN, AbstractUnitTypes.MACHINE, AbstractUnitTypes.BUILDING);
	
	//Building dependences
	public static final Set<Buildings> BASE_DEPENDENCE
		= new HashSet<Buildings>();
	
	public static final Set<Buildings> LABORATORY_DEPENDENCE
		= null;
	
	public static final EnumSet<Buildings> BARRACKS_DEPENDENCE
		= null;
	
	public static final Set<Buildings> ARCHERY_DEPENDENCE
		= null;
	
	public static final Set<Buildings> SMALL_WORKSHOP_DEPENDENCE
		= null;
	
	public static final Set<Buildings> BIG_WORKSHOP_DEPENDENCE
		= null;
	
	public static final Set<Buildings> SMALL_FACTORY_DEPENDENCE
		= null;
	
	public static final Set<Buildings> BIG_FACTORY_DEPENDENCE
		= null;
	
	//Other
	public static final int BUILDING_START_COST = 10;

	//Build times
	public static final int BASE_BUILD_TIME = 16;
	public static final int LABORATORY_BUILD_TIME = 9;
	public static final int BARRACKS_BUILD_TIME = 4;
	public static final int ARCHERY_BUILD_TIME = 5;
	public static final int SMALL_WORKSHOP_BUILD_TIME = 6;
	public static final int BIG_WORKSHOP_BUILD_TIME = 7;
	public static final int SMALL_FACTORY_BUILD_TIME = 8;
	public static final int BIG_FACTORY_BUILD_TIME = 9;
	
}
