package ru.amse.pomelov.starbugs.remote;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.EnumSet;

import ru.amse.pomelov.starbugs.server.GameField;
import ru.amse.pomelov.starbugs.turns.AbstractTurn;
import ru.amse.pomelov.starbugs.units.Buildings;
import ru.amse.pomelov.starbugs.units.Units;
import ru.amse.pomelov.starbugs.util.GameProperties;
import ru.amse.pomelov.starbugs.util.UserID;

public interface GameServer extends Remote {
	//TODO ,      .

	//Under a question
	public boolean registerGame(GameProperties props) throws RemoteException;
	public void nextPlayer(int player, int timeAvailable) throws RemoteException;

	
	//Always
	public boolean hasVacancy() throws RemoteException;
	public void monitor(RemoteGameServerListener listener) throws RemoteException;
	public GameProperties getProperties() throws RemoteException;
	public int getRegistredPlayerNum() throws RemoteException;
	public void forceKill() throws RemoteException; //Be careful;)
	
	//Before game start
	public UserID join(RemoteGameServerListener listener) throws RemoteException;
	
	//After registration
	public int makeTurn(UserID playerID, AbstractTurn turn) throws RemoteException;

	
	public GameField getGameField() throws RemoteException;
	public EnumSet<Units> getAllowedUnits() throws RemoteException;
	public EnumSet<Buildings> getAllowedBuildings() throws RemoteException;
}
