package ru.amse.pomelov.starbugs.remote;

import java.rmi.RemoteException;
import java.util.List;

import ru.amse.pomelov.starbugs.units.AbstractUnit;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public abstract class RemoteAdapter implements RemoteGameServerListener {


	/**
	 * {@inheritDoc}
	 */
	public void createUnits(List<AbstractUnit> l) throws RemoteException {}; 
	
    /**
     * {@inheritDoc}
     */
	public void gameStarted() throws RemoteException {}

    /**
     * {@inheritDoc}
     */
	public void playerJoined() throws RemoteException {}

    /**
     * {@inheritDoc}
     */
	public void removeUnits(List<FieldPosition> coordsList) throws RemoteException {};

    /**
     * {@inheritDoc}
     */
	public void yourTurn(int timeAvailable) throws RemoteException {}

    /**
     * {@inheritDoc}
     */
	public void endOfGame(int winner) throws RemoteException {};
	
}
