package ru.amse.pomelov.starbugs.turns;

import java.io.Serializable;

import ru.amse.pomelov.starbugs.server.GameDispatcher;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public abstract class AbstractTurn implements Serializable {
	protected final FieldPosition myObject;
	protected final FieldPosition mySubject;
	protected int player;
	public AbstractTurn(FieldPosition object, FieldPosition subject) {
		myObject = object;
		mySubject = subject;
	}
	
	public void setPlayer(int p) {
		player = p;
	}
	
	public int getPlayer() {
		return player;
	}
	/**
	 * Checks if the turn is available and returns its cost.
	 * @param player
	 * @param gd
	 * @return cost of the turn. -1 if the turn isn't available.
	 */
	public abstract int acceptTurn(GameDispatcher gd);
	
	/**
	 * Makes changes on the game field according to this turn.
	 * @param player
	 * @param gd
	 */
	public abstract void makeTurn(GameDispatcher gd);
}
