package ru.amse.pomelov.starbugs.units;

import java.util.EnumSet;

import javax.swing.ImageIcon;

import ru.amse.pomelov.starbugs.client.gui.IconFactory;
import ru.amse.pomelov.starbugs.util.FieldPosition;


public class Building extends AbstractUnit {

	private static final long serialVersionUID = 1L;
	
	private final Buildings myBuildingType;
	
	public Building(FieldPosition position, int player, Buildings buildingType) {
		super(position, player);
		myBuildingType = buildingType;
	}

	@Override
	public int getAttackCost() {
		return 0;
	}

	@Override
	public int getAttackRadiuses() {
		return 0;
	}

	@Override
	public EnumSet<AbstractUnitTypes> getAttackTypes() {
		return EnumSet.noneOf(AbstractUnitTypes.class);
	}

	@Override
	public int getCost() {
		return 0;
	}

	@Override
	public boolean isAbleToBuild() {
		return false;
	}

	public Buildings getBuildingType() {
		return myBuildingType;
	}

	@Override
	public AbstractUnitTypes getType() {
		return AbstractUnitTypes.BUILDING;
	}

	@Override
	public String toString() {
		if (myBuildingType == Buildings.ARCHERY) {
			return "ARC";
		} else if (myBuildingType == Buildings.BARRACKS) {
			return "BRK";
		} else if (myBuildingType == Buildings.BASE) {
			return "BAS";
		} else if (myBuildingType == Buildings.BIG_FACTORY) {
			return "BFC";
		} else if (myBuildingType == Buildings.BIG_WORKSHOP) {
			return "BWS";
		} else if (myBuildingType == Buildings.LABORATORY) {
			return "LAB";
		} else if (myBuildingType == Buildings.SMALL_FACTORY) {
			return "SFC";
		} else if (myBuildingType == Buildings.SMALL_WORKSHOP) {
			return "SWS";
		} else {
			return "   ";
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Building)) {
			return false;
		}
		Building you = (Building)obj;
		return super.equals(obj) && (myBuildingType == you.getBuildingType());
	}

	@Override
	public int hashCode() {
		return super.hashCode() + 47 * myBuildingType.hashCode();
	}

	@Override
	public ImageIcon acceptIconFacory() {
		return IconFactory.createIcon(this);
	}
	
	
}
