package ru.amse.pomelov.starbugs.units;

import java.util.HashSet;
import java.util.Set;

public enum Buildings {
	BASE("Base"),
	LABORATORY("Laboratory", BASE),
	BARRACKS("Barracks", BASE),
	ARCHERY("Archery", BASE, BARRACKS),
	SMALL_WORKSHOP("SmallWorkshop", BASE, BARRACKS, LABORATORY),
	BIG_WORKSHOP("BigWorkshop", BASE, LABORATORY, ARCHERY),
	SMALL_FACTORY("SmallFactory", BASE, LABORATORY, SMALL_WORKSHOP),
	BIG_FACTORY("BigFactory", BASE, BARRACKS, LABORATORY,
				 SMALL_FACTORY, BIG_WORKSHOP);
	
	
	private Buildings(String name, Buildings ...dep) {
		myName = name;
		for (Buildings b : dep) {
			myDependence.add(b);
		}
	}
	
	private final Set<Buildings> myDependence = new HashSet<Buildings>();
	private final String myName;
	
	public Set<Buildings> getDependence() {
		return myDependence;
	}
	
	public String getName() {
		return myName;
	}
}
