package ru.amse.pomelov.starbugs.units;

import ru.amse.pomelov.starbugs.util.FieldPosition;

public class Edifice{
	private final FieldPosition myPosition;
	private final Edifices myType;
	
	private int alreadyBuilt = 0;

	
	public Edifice(FieldPosition position, Edifices type) {
		myPosition = position;
		myType = type;
	}

	public FieldPosition getPosition() {
		return myPosition;
	}
	
	public boolean proceed() {
		alreadyBuilt++;
		return myType.getBuildTime() == alreadyBuilt;
	}
	
	public int alreadyBuilt() {
		return alreadyBuilt;
	}
	
	public Edifices getEdificeType() {
		return myType;
	}
}
