package ru.amse.pomelov.starbugs.util;

import java.util.*;

public class SurroundGenerator implements Iterable<FieldPosition>, Iterator<FieldPosition> {

	private List<FieldPosition> mySurroundList;
	private Iterator<FieldPosition> myIterator;
	
	public SurroundGenerator(FieldPosition start) {
		mySurroundList = new ArrayList<FieldPosition>();
		int x = start.getX();
		int y = start.getY();
		for (int i = -1; i < 2; i++) {
			for (int j = -1; j < 2; j++) {
				if ((i != 0) || (j != 0)) {
					mySurroundList.add(FieldPosition.createPoint(x + i, y + j));
				}
			}
		}
		myIterator = mySurroundList.iterator();
	}
	
	public boolean hasNext() {
		return myIterator.hasNext(); 
	}
	
	public FieldPosition next() {
		return myIterator.next();
	}
	
	public Iterator<FieldPosition> iterator() {
		return this;
	}

	public void remove() {
		throw new UnsupportedOperationException();
	}	
}
