package ru.amse.pomelov.starbugs.server.testing;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

import ru.amse.pomelov.starbugs.server.GameField;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public class Saver implements Visitor {

	private OutputStream myOut;
	
	public Saver(OutputStream out) {
		myOut = out;
	}

	public void visitGameField(GameField gf) {
		try {
			ObjectOutputStream out = new ObjectOutputStream(myOut);
			out.writeInt(gf.getWidth());
			out.writeInt(gf.getHeight());
			for (int i = 0; i < gf.getWidth(); i++) {
				for (int j = 0; j < gf.getHeight(); j++) {
					out.writeObject(gf.getUnit(FieldPosition.createPoint(i, j)));
				}
			}
			out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
