package ru.amse.pomelov.starbugs.server.testing;

import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;

import ru.amse.pomelov.starbugs.server.GameField;
import ru.amse.pomelov.starbugs.units.AbstractUnit;
import ru.amse.pomelov.starbugs.util.FieldPosition;

public class Visualizator implements Visitor {

	private final OutputStream myFOS; 
	
	
	
	
	public Visualizator(OutputStream fos) {
		myFOS = fos;
	}
	
	public Visualizator() {
		this(System.out);
	}
	
	public void visitGameField(GameField gf) {
		try {
			Writer writer = new OutputStreamWriter(myFOS, "Cp866");
			int width = gf.getWidth();
			int height = gf.getHeight();
			
			for (int i = 0; i < height; i++) {
				for (int j = 0; j < width * 4 + 1; j++) {
					writer.write('-');
				}
				writer.write('\n');
				for (int j = 0; j < width; j++) {
					writer.write('|');
					AbstractUnit su = gf.getUnit(FieldPosition.createPoint(i, j));
					writer.write((su == null) ? "   " : su.toString());
				}
				writer.write("|\n");
			}
			for (int j = 0; j < width * 4 + 1; j++) {
				writer.write('-');
			}
			writer.write('\n');
			writer.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
